# Apache Tomcat 6.0

Version 6.0.53, Apr 2 2017

Links

- Docs Home
- Config Ref. Home

Top Level Elements

- Server
- Service

Executors

- Executor

Connectors

- HTTP
- AJP

Containers

- Context
- Engine
- Host
- Cluster

Nested Components

- Global Resources
- Listeners
- Loader
- Manager
- Realm
- Resources
- Valve

Cluster Elements

- Cluster
- Manager
- Channel
- Channel/Membership
- Channel/Sender
- Channel/Receiver
- Channel/Interceptor
- Valve
- Deployer
- ClusterListener

web.xml

- Filter

Other

- System properties

# Apache Tomcat Configuration Reference

## The HTTP Connector

Table of Contents

> - Introduction
> - Attributes
>   1. Common Attributes
>   2. Standard Implementation
>   3. Nio Implementation
> - Nested Components
> - Special Features
>   1. HTTP/1.1 and HTTP/1.0 Support
>   2. Proxy Support
>   3. SSL Support
>   4. Connector Comparison

Introduction

> The HTTP Connector element represents a Connector component that supports the HTTP/1.1 protocol. It enables Catalina to function as a stand-alone web server, in addition to its ability to execute servlets and JSP pages. A particular instance of this component listens for connections on a specific TCP port number on the server. One or more such Connectors can be configured as part of a single Service, each forwarding to the associated Engine to perform request processing and create the response.

> If you wish to configure the Connector that is used for connections to web servers using the AJP protocol (such as the `mod_jk 1.2.x` connector for Apache 1.3), see here instead.

> Each incoming request requires a thread for the duration of that request. If more simultaneous requests are received than can be handled by the currently available request processing threads, additional threads will be created up to the configured maximum (the value of the `maxThreads` attribute). If still more simultaneous requests are received, they are stacked up inside the server socket created by the Connector, up to the configured maximum (the value of the `acceptCount` attribute). Any further simultaneous requests will receive "connection refused" errors, until resources are available to process them.

Attributes

> Common Attributes

> > All implementations of Connector support the following attributes:

> > Attribute | Description
> > --- | ---
> > `allowTrace` | A boolean value which can be used to enable or disable the TRACE HTTP method. If not specified, this attribute is set to false.
> > `emptySessionPath` | If set to `true`, all paths for session cookies will be set to `/`. This can be useful for portlet specification implementations. If not specified, this attribute is set to `false`. A side effect to setting this to true, is that if Tomcat creates a new session it will attempt to use the cookie session id if supplied by the client. SVN check in Dev discussion Work around
> > `enableLookups` | Set to `true` if you want calls to `request.getRemoteHost()` to perform DNS lookups in order to return the actual host name of the remote client. Set to `false` to skip the DNS lookup and return the IP address in String form instead (thereby improving performance). By default, DNS lookups are disabled.
> > `maxHeaderCount` | The maximum number of headers in a request that are allowed by the container. A request that contains more headers than the specified limit will be rejected. A value of less than 0 means no limit. If not specified, a default of 100 is used.
> > `maxParameterCount` | The maximum number of parameters (GET plus POST) which will be automatically parsed by the container. A value of less than 0 means no limit. If not specified, a default of 10000 is used. Note that `FailedRequestFilter` filter can be used to reject requests that hit the limit.
> > `maxPostSize` | The maximum size in bytes of the POST which will be handled by the container FORM URL parameter parsing. The limit can be disabled by setting this attribute to a value less than or equal to 0. If not specified, this attribute is set to 2097152 (2 megabytes).

> > `maxSavePostSize`

> > The maximum size in bytes of the POST which will be saved/buffered by the container during FORM or CLIENT-CERT authentication. For both types of authentication, the POST will be saved/buffered before the user is authenticated. For CLIENT-CERT authentication, the POST is buffered for the duration of the SSL handshake and the buffer emptied when the request is processed. For FORM authentication the POST is saved whilst the user is re-directed to the login form and is retained until the user successfully authenticates or the session associated with the authentication request expires. The limit can be disabled by setting this attribute to -1. Setting the attribute to zero will disable the saving of POST data during authentication. If not specified, this attribute is set to 4096 (4 kilobytes).

> > `parseBodyMethods`

> > A comma-separated list of HTTP methods for which request bodies will be parsed for request parameters identically to POST. This is useful in RESTful applications that want to support POST-style semantics for PUT requests. Note that any setting other than `POST` causes Tomcat to behave in a way that does against the intent of the servlet specification. The HTTP method TRACE is specifically forbidden here in accordance with the HTTP specification. The default is `POST`

> > `port`

> > The TCP port number on which this Connector will create a server socket and await incoming connections. Your operating system will allow only one server application to listen to a particular port number on a particular IP address. If the special value of 0 (zero) is used, then Tomcat will select a free port at random to use for this connector. This is typically only useful in embedded and testing applications.

> > `protocol`

> > Sets the protocol to handle incoming traffic. The default value is `HTTP/1.1` and configures the `org.apache.coyote.http11.Http11Protocol`. This is the blocking Java connector.
> > If the `PATH` (Windows) or `LD_LIBRARY_PATH` (on most unix systems) environment variables contain the Tomcat native library, the APR connector will automatically be configured. Please be advised that the APR connector has different settings for HTTPS than the default Java connector.
> > Other values for this attribute are, but not limited to:
> > `org.apache.coyote.http11.Http11Protocol` - same as HTTP/1.1
> > `org.apache.coyote.http11.Http11NioProtocol` - non blocking Java connector
> > `org.apache.coyote.http11.Http11AprProtocol` - the APR connector.
> > Take a look at our Connector Comparison chart. The configuration for both Java connectors are identical, both for http and https.
> > For more information on the APR connector and APR specific SSL settings please visit the APR documentation

> > `proxyName` | If this Connector is being used in a proxy configuration, configure this attribute to specify the server name to be returned for calls to `request.getServerName()`. See Proxy Support for more information.
> > `proxyPort` | If this Connector is being used in a proxy configuration, configure this attribute to specify the server port to be returned for calls to `request.getServerPort()`. See Proxy Support for more information.
> > `redirectPort` | If this Connector is supporting non-SSL requests, and a request is received for which a matching `<security-constraint>` requires SSL transport, Catalina will automatically redirect the request to the port number specified here.

> > `SSLEnabled`

> > Use this attribute to enable SSL traffic on a connector. To turn on SSL handshake/encryption/decryption on a connector set this value to `true`. The default value is `false`. When turning this value `true` you will want to set the `scheme` and the `secure` attributes as well to pass the correct `request.getScheme()` and `request.isSecure()` values to the servlets See SSL Support for more information.

> > `scheme` | Set this attribute to the name of the protocol you wish to have returned by calls to `request.getScheme()`. For example, you would set this attribute to "`https`" for an SSL Connector. The default value is "`http`".
> > `secure` | Set this attribute to `true` if you wish to have calls to `request.isSecure()` to return `true` for requests received by this Connector. You would want this on an SSL Connector or a non SSL connector that is receiving data from a SSL accelerator, like a crypto card, a SSL appliance or even a webserver. The default value is `false`.
> > `URIEncoding` | This specifies the character encoding used to decode the URI bytes, after %xx decoding the URL. If not specified, ISO-8859-1 will be used.

> > `useBodyEncodingForURI`

> > This specifies if the encoding specified in contentType should be used for URI query parameters, instead of using the URIEncoding. This setting is present for compatibility with Tomcat 4.1.x, where the encoding specified in the contentType, or explicitly set using Request.setCharacterEncoding method was also used for the parameters from the URL. The default value is `false`.

> > `useIPVHosts` | Set this attribute to `true` to cause Tomcat to use the IP address that the request was received on to determine the Host to send the request to. The default value is `false`.
> > `xpoweredBy` | Set this attribute to `true` to cause Tomcat to advertise support for the Servlet specification using the header recommended in the specification. The default value is `false`.

> Standard Implementation

> > HTTP supports the following additional attributes (in addition to the common attributes listed above):

> > Attribute | Description
> > --- | ---
> > `acceptCount` | The maximum queue length for incoming connection requests when all possible request processing threads are in use. Any requests received when the queue is full will be refused. The default value is 100.
> > `address` | For servers with more than one IP address, this attribute specifies which address will be used for listening on the specified port. By default, this port will be used on all IP addresses associated with the server.
> > `bufferSize` | The size (in bytes) of the buffer to be provided for input streams created by this connector. By default, buffers of 2048 bytes will be provided.
> > `compressableMimeType` | The value is a comma separated list of MIME types for which HTTP compression may be used. The default value is `text/html,text/xml,text/plain`.

> > `compression`

> > The Connector may use HTTP/1.1 GZIP compression in an attempt to save server bandwidth. The acceptable values for the parameter is "off" (disable compression), "on" (allow compression, which causes text data to be compressed), "force" (forces compression in all cases), or a numerical integer value (which is equivalent to "on", but specifies the minimum amount of data before the output is compressed). If the content-length is not known and compression is set to "on" or more aggressive, the output will also be compressed. If not specified, this attribute is set to "off".

> > Note: There is a tradeoff between using compression (saving your bandwidth) and using the sendfile feature (saving your CPU cycles). If the connector supports the sendfile feature, e.g. the NIO connector, using sendfile will take precedence over compression. The symptoms will be that static files greater that 48 Kb will be sent uncompressed. You can turn off sendfile by setting `useSendfile` attribute of the connector, as documented below, or change the sendfile usage threshold in the configuration of the DefaultServlet in the default `conf/web.xml` or in the `web.xml` of your web application.

> > `connectionLinger` | The number of seconds during which the sockets used by this Connector will linger when they are closed. Setting this attribute to `-1` will disable connection linger. The default value for the BIO and AJP connectors is 100. The default value for the NIO connection is 25.
> > `connectionTimeout` | The number of milliseconds this Connector will wait, after accepting a connection, for the request URI line to be presented. The default value is 60000 (i.e. 60 seconds).
> > `executor` | A reference to the name in an Executor element. If this attribute is enabled, and the named executor exists, the connector will use the executor, and all the other thread attributes will be ignored.
> > `keepAliveTimeout` | The number of milliseconds this Connector will wait for another HTTP request before closing the connection. The default value is to use the value that has been set for the connectionTimeout attribute.
> > `disableUploadTimeout` | This flag allows the servlet container to use a different, longer connection timeout while a servlet is being executed, which in the end allows either the servlet a longer amount of time to complete its execution, or a longer timeout during data upload. If not specified, this attribute is set to "true".
> > `maxCookieCount` | The maximum number of cookies that are permitted for a request. A value of less than zero means no limit. If not specified, a default value of 200 will be used.
> > `maxHttpHeaderSize` | The maximum size of the request and response HTTP header, specified in bytes. If not specified, this attribute is set to 8192 (8 KB).
> > `maxKeepAliveRequests` | The maximum number of HTTP requests which can be pipelined until the connection is closed by the server. Setting this attribute to 1 will disable HTTP/1.0 keep-alive, as well as HTTP/1.1 keep-alive and pipelining. Setting this to -1 will allow an unlimited amount of pipelined or keep-alive HTTP requests. If not specified, this attribute is set to 100.

> > `maxThreads`

> > The maximum number of request processing threads to be created by this Connector, which therefore determines the maximum number of simultaneous requests that can be handled. If not specified, this attribute is set to 200. If an executor is associated with this connector, this attribute is ignored as the connector will execute tasks using the executor rather than an internal thread pool.

> > `noCompressionUserAgents` | The value is a comma separated list of regular expressions matching user-agents of HTTP clients for which compression should not be used, because these clients, although they do advertise support for the feature, have a broken implementation. The default value is an empty String (regexp matching disabled).
> > `port` | The TCP port number on which this Connector will create a server socket and await incoming connections. Your operating system will allow only one server application to listen to a particular port number on a particular IP address.
> > `restrictedUserAgents` | The value is a comma separated list of regular expressions matching user-agents of HTTP clients for which HTTP/1.1 or HTTP/1.0 keep alive should not be used, even if the clients advertise support for these features. The default value is an empty String (regexp matching disabled).
> > `server` | Overrides the Server header for the http response. If set, the value for this attribute overrides the Tomcat default and any Server header set by a web application. If not set, any value specified by the application is used. If the application does not specify a value then `Apache-Coyote/1.1` is used. Unless you are paranoid, you won't need this feature.
> > `socketBuffer` | The size (in bytes) of the buffer to be provided for socket output buffering. -1 can be specified to disable the use of a buffer. By default, a buffers of 9000 bytes will be used.
> > `tcpNoDelay` | If set to `true`, the TCP_NO_DELAY option will be set on the server socket, which improves performance under most circumstances. This is set to `true` by default.
> > `threadPriority` | The priority of the request processing threads within the JVM. The default value is `5` (the value of the `java.lang.Thread.NORM_PRIORITY` constant). See the JavaDoc for the `java.lang.Thread` class for more details on what this priority means.

> Nio Implementation

> > The NIO connector exposes all the low level socket properties that can be used to tune the connector. Most of these attributes are directly linked to the socket implementation in the JDK so you can find out about the actual meaning in the JDK API documentation.
> > Note: On some JDK versions, setTrafficClass causes a problem, a work around for this is to add the `-Djava.net.preferIPv4Stack=true` value to your command line

> > Attribute | Description
> > --- | ---
> > `useSendfile` | (bool)Use this attribute to enable or disable sendfile capability. The default value is `true`

> > `useExecutor`

> > (bool)Set to true to use the NIO thread pool executor. The default value is `true`. If set to false, it uses a thread pool based on a stack for its execution. Generally, using the executor yields a little bit slower performance, but yields a better fairness for processing connections in a high load environment as the traffic gets queued through a FIFO queue. If set to true(default) then the max pool size is the `maxThreads` attribute and the core pool size is the `minSpareThreads`. This value is ignored if the `executor` attribute is present and points to a valid shared thread pool.

> > `executor` | A reference to the name in an Executor element. If this attribute is enabled, and the named executor exists, the connector will use the executor, and all the other thread attributes will be ignored.
> > `acceptorThreadCount` | (int)The number of threads to be used to accept connections. Increase this value on a multi CPU machine, although you would never really need more than `2`. Also, with a lot of non keep alive connections, you might want to increase this value as well. Default value is `1`.
> > `pollerThreadCount` | (int)The number of threads to be used to run for the polling events. Default value is `1` per processor. Can't see a reason to go above that. But experiment and find your own results.
> > `pollerThreadPriority` | (int)The priority of the poller threads. The default value is `5` (the value of the `java.lang.Thread.NORM_PRIORITY` constant). See the JavaDoc for the `java.lang.Thread` class for more details on what this priority means.
> > `acceptorThreadPriority` | (int)The priority of the acceptor threads. The threads used to accept new connections. The default value is `5` (the value of the `java.lang.Thread.NORM_PRIORITY` constant). See the JavaDoc for the `java.lang.Thread` class for more details on what this priority means.
> > `selectorTimeout` | (int)The time in milliseconds to timeout on a select() for the poller. This value is important, since connection clean up is done on the same thread, so do not set this value to an extremely high one. The default value is `1000` milliseconds.
> > `useComet` | (bool)Whether to allow comet servlets or not, Default value is `true`.
> > `processorCache` | (int)The protocol handler caches Http11NioProcessor objects to speed up performance. This setting dictates how many of these objects get cached. `-1` means unlimited, default is `200`. Set this value somewhere close to your maxThreads value.
> > `maxKeepAliveRequests` | The maximum number of HTTP requests which can be pipelined until the connection is closed by the server. Setting this attribute to 1 will disable HTTP/1.0 keep-alive, as well as HTTP/1.1 keep-alive and pipelining. Setting this to -1 will allow an unlimited amount of pipelined or keep-alive HTTP requests. If not specified, this attribute is set to 100.
> > `socket.directBuffer` | (bool)Boolean value, whether to use direct ByteBuffers or java mapped ByteBuffers. Default is `false` When you are using direct buffers, make sure you allocate the appropriate amount of memory for the direct memory space. On Sun's JDK that would be something like `-XX:MaxDirectMemorySize=256m`
> > `socket.rxBufSize` | (int)The socket receive buffer (SO_RCVBUF) size in bytes. Default value is `25188`
> > `socket.txBufSize` | (int)The socket send buffer (SO_SNDBUF) size in bytes. Default value is `43800`
> > `socket.appReadBufSize` | (int)Each connection that is opened up in Tomcat get associated with a read and a write ByteBuffer This attribute controls the size of these buffers. By default this read buffer is sized at `8192` bytes. For lower concurrency, you can increase this to buffer more data. For an extreme amount of keep alive connections, decrease this number or increase your heap size.

> > `socket.appWriteBufSize`

> > (int)Each connection that is opened up in Tomcat get associated with a read and a write ByteBuffer This attribute controls the size of these buffers. By default this write buffer is sized at `8192` bytes. For low concurrency you can increase this to buffer more response data. For an extreme amount of keep alive connections, decrease this number or increase your heap size.
> > The default value here is pretty low, you should up it if you are not dealing with tens of thousands concurrent connections.

> > `socket.bufferPool` | (int)The Nio connector uses a class called NioChannel that holds elements linked to a socket. To reduce garbage collection, the Nio connector caches these channel objects. This value specifies the size of this cache. The default value is `500`, and represents that the cache will hold 500 NioChannel objects. Other values are `-1`. unlimited cache, and `0`, no cache.

> > `socket.bufferPoolSize`

> > (int)The NioChannel pool can also be size based, not used object based. The size is calculated as follows:
> > NioChannel `buffer size = read buffer size + write buffer size`
> > SecureNioChannel `buffer size = application read buffer size + application write buffer size + network read buffer size + network write buffer size`
> > The value is in bytes, the default value is `1024*1024*100` (100MB)

> > `socket.processorCache` | (int)Tomcat will cache SocketProcessor objects to reduce garbage collection. The integer value specifies how many objects to keep in the cache at most. The default is `500`. Other values are `-1`. unlimited cache, and `0`, no cache.
> > `socket.keyCache` | (int)Tomcat will cache KeyAttachment objects to reduce garbage collection. The integer value specifies how many objects to keep in the cache at most. The default is `500`. Other values are `-1`. unlimited cache, and `0`, no cache.
> > `socket.eventCache` | (int)Tomcat will cache PollerEvent objects to reduce garbage collection. The integer value specifies how many objects to keep in the cache at most. The default is `500`. Other values are `-1`. unlimited cache, and `0`, no cache.
> > `socket.tcpNoDelay` | (bool)same as the standard setting `tcpNoDelay`. Default value is `false`
> > `socket.soKeepAlive` | (bool)Boolean value for the socket's keep alive setting (SO_KEEPALIVE). Default is `false`.
> > `socket.ooBInline` | (bool)Boolean value for the socket OOBINLINE setting. Default value is `true`
> > `socket.soReuseAddress` | (bool)Boolean value for the sockets reuse address option (SO_REUSEADDR). Default value is `true`
> > `socket.soLingerOn` | (bool)Boolean value for the sockets so linger option (SO_LINGER). Default value is `true`. This option is paired with the `soLingerTime` value.
> > `socket.soLingerTime` | (bool)Value in seconds for the sockets so linger option (SO_LINGER). Default value is `25` seconds. This option is paired with the soLinger value.
> > `socket.soTimeout` | (int)Value in milliseconds for the sockets read timeout (SO_TIMEOUT). Default value is `5000` milliseconds.
> > `socket.soTrafficClass` | (byte)Value between `0` and `255` for the traffic class on the socket, `0x04 | 0x08 | 0x010`
> > `socket.performanceConnectionTime` | (int)The first value for the performance settings. Default is `1`, see Socket Performance Options
> > `socket.performanceLatency` | (int)The second value for the performance settings. Default is `0`, see Socket Performance Options
> > `socket.performanceBandwidth` | (int)The third value for the performance settings. Default is `1`, see Socket Performance Options
> > `selectorPool.maxSelectors` | (int)The max selectors to be used in the pool, to reduce selector contention. Use this option when the command line `org.apache.tomcat.util.net.NioSelectorShared` value is set to false. Default value is `200`.
> > `selectorPool.maxSpareSelectors` | (int)The max spare selectors to be used in the pool, to reduce selector contention. When a selector is returned to the pool, the system can decide to keep it or let it be GC:ed. Use this option when the command line `org.apache.tomcat.util.net.NioSelectorShared` value is set to false. Default value is `-1` (unlimited)
> > `command-line-options` | The following command line options are available for the NIO connector: `-Dorg.apache.tomcat.util.net.NioSelectorShared=true|false` - default is `true`. Set this value to `false` if you wish to use a selector for each thread. When you set it to `false`, you can control the size of the pool of selectors by using the selectorPool.maxSelectors attribute

> > `oomParachute`

> > (int)The NIO connector implements an OutOfMemoryError strategy called parachute. It holds a chunk of data as a byte array. In case of an OOM, this chunk of data is released and the error is reported. This will give the VM enough room to clean up. The `oomParachute` represent the size in bytes of the parachute(the byte array). The default value is `1024*1024`(1MB). Please note, this only works for OOM errors regarding the Java Heap space, and there is absolutely no guarantee that you will be able to recover at all. If you have an OOM outside of the Java Heap, then this parachute trick will not help.

> > `socket.unlockTimeout` | (int) The timeout for a socket unlock. When a connector is stopped, it will try to release the acceptor thread by opening a connector to itself. The default value is `250` and the value is in milliseconds

Nested Components

> None at this time.

Special Features

> HTTP/1.1 and HTTP/1.0 Support

> > This Connector supports all of the required features of the HTTP/1.1 protocol, as described in RFC 2616, including persistent connections, pipelining, expectations and chunked encoding. If the client (typically a browser) supports only HTTP/1.0, the Connector will gracefully fall back to supporting this protocol as well. No special configuration is required to enable this support. The Connector also supports HTTP/1.0 keep-alive.

> > RFC 2616 requires that HTTP servers always begin their responses with the highest HTTP version that they claim to support. Therefore, this Connector will always return `HTTP/1.1` at the beginning of its responses.

> Proxy Support

> > The `proxyName` and `proxyPort` attributes can be used when Tomcat is run behind a proxy server. These attributes modify the values returned to web applications that call the `request.getServerName()` and `request.getServerPort()` methods, which are often used to construct absolute URLs for redirects. Without configuring these attributes, the values returned would reflect the server name and port on which the connection from the proxy server was received, rather than the server name and port to whom the client directed the original request.

> > For more information, see the Proxy Support HOW-TO.

> SSL Support

> > You can enable SSL support for a particular instance of this Connector by setting the `SSLEnabled` attribute to `true`.

> > You will also need to set the `scheme` and `secure` attributes to the values `https` and `true` respectively, to pass correct information to the servlets.

> > In addition, you may need to configure the following attributes:

> > Attribute | Description
> > --- | ---
> > `algorithm` | The certificate encoding algorithm to be used. This defaults to `KeyManagerFactory.getDefaultAlgorithm()` which returns `SunX509` for Sun JVMs. IBM JVMs return `IbmX509`. For other vendors, consult the JVM documentation for the default value.

> > `clientAuth`

> > Set to `true` if you want the SSL stack to require a valid certificate chain from the client before accepting a connection. Set to `want` if you want the SSL stack to request a client Certificate, but not fail if one isn't presented. A `false` value (which is the default) will not require a certificate chain unless the client requests a resource protected by a security constraint that uses `CLIENT-CERT` authentication. See the SSL HowTo for an example.

> > `clientCertProvider`

> > When client certificate information is presented in a form other than instances of `java.security.cert.X509Certificate` it needs to be converted before it can be used and this property controls which JSSE provider is used to perform the conversion. For example it is used with the AJP connectors, the HTTP APR connector and with the org.apache.catalina.valves.SSLValve. If not specified, the default provider will be used.

> > `keystoreFile` | The pathname of the keystore file where you have stored the server certificate to be loaded. By default, the pathname is the file "`.keystore`" in the operating system home directory of the user that is running Tomcat. If your `keystoreType` doesn't need a file use `""` (empty string) for this parameter.
> > `keystorePass` | The password used to access the server certificate from the specified keystore file. The default value is "`changeit`".
> > `keystoreType` | The type of keystore file to be used for the server certificate. If not specified, the default value is "`JKS`".
> > `keystoreProvider` | The name of the keystore provider to be used for the server certificate. If not specified, the list of registered providers is traversed in preference order and the first provider that supports the `keystoreType` is used.

> > `sslProtocol`

> > The SSL protocol(s) to use (a single value may enable multiple protocols - see the JVM documentation for details). If not specified, the default is `TLS`. The permitted values may be obtained from the JVM documentation for the allowed values for algorithm when creating an `SSLContext` instance e.g. Oracle Java 6 and Oracle Java 7. Note: There is overlap between this attribute and `sslEnabledProtocols`.

> > `ciphers`

> > The comma separated list of encryption ciphers to support for HTTPS connections. If specified, only the ciphers that are listed and supported by the SSL implementation will be used. By default, the default ciphers for the JVM will be used less those considered to be insecure. Note that with older JVMs this will result in a very limited set of ciphers being available by default. The ciphers are specified using the JSSE cipher naming convention. The special value of `ALL` will enable all supported ciphers. This will include many that are not secure. `ALL` is intended for testing purposes only.

> > `keyAlias`

> > The alias used for the server key and certificate in the keystore. If not specified, the first key read from the keystore will be used. The order in which keys are read from the keystore is implementation dependent. It may not be the case that keys are read from the keystore in the same order as they were added. If more than one key is present in the keystore it is strongly recommended that a keyAlias is configured to ensure that the correct key is used.

> > `trustManagerClassName` | The name of a custom trust manager class to use to validate client certificates. The class must have a zero argument constructor and must also implement `javax.net.ssl.X509TrustManager`. If this attribute is set, the trust store attributes may be ignored.
> > `truststoreFile` | The trust store file to use to validate client certificates. The default is the value of the `javax.net.ssl.trustStore` system property. If neither this attribute nor the default system property is set, no trust store will be configured.

> > `truststorePass`

> > The password to access the trust store. The default is the value of the `javax.net.ssl.trustStorePassword` system property. If that property is null, the value of `keystorePass` is used as the default. If an invalid trust store password is specified, a warning will be logged and an attempt will be made to access the trust store without a password which will skip validation of the trust store contents. If the trust store password is defined as `""` then no password will be used to access the store which will also skip validation of the trust store contents.

> > `truststoreType` | The type of key store used for the trust store. The default is the value of the `javax.net.ssl.trustStoreType` system property. If that property is null, the value of `keystoreType` is used as the default.

> > `truststoreProvider`

> > The name of the truststore provider to be used for the server certificate. The default is the value of the `javax.net.ssl.trustStoreProvider` system property. If that property is null, the value of `keystoreProvider` is used as the default. If neither this attribute, the default system property nor `keystoreProvider`is set, the list of registered providers is traversed in preference order and the first provider that supports the `truststoreType` is used.

> > `sessionCacheSize` | The number of SSL sessions to maintain in the session cache. Use 0 to specify an unlimited cache size. If not specified, a default of 0 is used.
> > `sessionTimeout` | The time, in seconds, after the creation of an SSL session that it will timeout. Use 0 to specify an unlimited timeout. If not specified, a default of 86400 (24 hours) is used.

> > `sslEnabledProtocols`

> > The comma separated list of SSL protocols to support for HTTPS connections. If specified, only the protocols that are listed and supported by the SSL implementation will be enabled. If not specified, the JVM default (excluding SSLv2 and SSLv3 if the JVM enables either or both of them by default) is used. The permitted values may be obtained from the JVM documentation for the allowed values for `SSLSocket.setEnabledProtocols()` e.g. Oracle Java 6 and Oracle Java 7. Note: There is overlap between this attribute and `sslProtocol`.

> > `crlFile` | The certificate revocation list file to use to validate client certificates.

> > `allowUnsafeLegacyRenegotiation`

> > Is unsafe legacy TLS renegotiation allowed which is likely to expose users to CVE-2009-3555, a man-in-the-middle vulnerability in the TLS protocol that allows an attacker to inject arbitrary data into the user's request. If not specified, a default of `false` is used. This attribute only has an effect if the JVM does not support RFC 5746 as indicated by the presence of the pseudo-ciphersuite TLS_EMPTY_RENEGOTIATION_INFO_SCSV. This is available JRE/JDK 6 update 22 onwards. Where RFC 5746 is supported the renegotiation - including support for unsafe legacy renegotiation - is controlled by the JVM configuration.

> > For more information, see the SSL Configuration HOW-TO.

> Connector Comparison

> > Below is a small chart that shows how the connectors differentiate.

> >                       Java Blocking Connector       Java Nio Blocking Connector       APR Connector
> >         Classname         Http11Protocol                  Http11NioProtocol         Http11AprProtocol
> >         Tomcat Version   3.x 4.x 5.x 6.x                       6.x                     5.5.x 6.x
> >         Support Polling         NO                             YES                        YES
> >         Polling Size           N/A                   Unlimited - Restricted by mem        Unlimited - Configurable
> >         Read HTTP Request     Blocking                     Non Blocking                   Blocking
> >         Read HTTP Body        Blocking                     Sim Blocking                   Blocking
> >         Write HTTP Response   Blocking                     Sim Blocking                   Blocking
> >         SSL Support           Java SSL                     Java SSL                       OpenSSL
> >         SSL Handshake         Blocking                     Non blocking                   Blocking
> >         Max Connections       maxThreads                   See polling size               See polling size

Copyright © 1999-2017, Apache Software Foundation